cc.Class({
    extends: cc.Component,

    properties: {
        _downloadNode: null,
    },

    onLoad: function() {
        this.node.getChildByName('button').on('touchend', function() {
            this.getfiles('bjl', 2);
        }, this);
    },

    initLoad: function() {
        /*  if (!this._downloadNode) {
             cc.loader.loadRes('download', cc.Prefab, (error, prefab) => {
                 this._downloadNode = cc.instantiate(prefab);
                 this._downloadNode.parent = this.node;
                 //console.log(this.node.loadGame);
                 this.loadGame(this.node.loadGame);
             });
         } else {
             this._downloadNode.active = true;
             this.loadGame(this.node.loadGame);
         } */
    },

    loadGame: function(gameName) {
        if (cc.sys.isNative) {
            console.log('loadGame', this._updating);
            this.getfiles(gameName);
        } else {
            this.getWebGame(gameName);
            cc.sys.openURL('http://192.168.0.143:7456');
        }
    },

    getWebGame: function(name) {
        console.log('web:', name);
    },

    getfiles: function(name, mmm) {
        if (this._updateListener) {
            cc.eventManager.removeListener(this._updateListener);
            this._updateListener = null;
        }
        if (this._checkListener) {
            cc.eventManager.removeListener(this._checkListener);
            this._checkListener = null;
        }
        if (this._am && !cc.sys.ENABLE_GC_FOR_NATIVE_OBJECTS) {
            this._am.release();
        }
        this.name = name;
        this._storagePath = ((jsb.fileUtils ? jsb.fileUtils.getWritablePath() : '/') + 'ALLGames/' + name);
        let UIRLFILE = "";
        if (name == "bjl") {
            UIRLFILE = "http://192.168.0.178/AllGames/" + name;
        } else {
            return;
        }
        let filees = this._storagePath + "/project.manifest";
        this.manifestUrl = filees;
        this.customManifestStr = JSON.stringify({
            "packageUrl": UIRLFILE,
            "remoteManifestUrl": UIRLFILE + "/project.manifest",
            "remoteVersionUrl": UIRLFILE + "/version.manifest",
            "version": "0.0.1",
            "assets": {},
            "searchPaths": []
        });

        var versionCompareHandle = function(versionA, versionB) {
            cc.log("JS Custom Version Compare: version A is " + versionA + ', version B is ' + versionB);
            var vA = versionA.split('.');
            var vB = versionB.split('.');
            for (var i = 0; i < vA.length; ++i) {
                var a = parseInt(vA[i]);
                var b = parseInt(vB[i] || 0);
                if (a === b) {
                    continue;
                } else {
                    return a - b;
                }
            }
            if (vB.length > vA.length) {
                return -1;
            } else {
                return 0;
            }
        };

        this._am = new jsb.AssetsManager('', this._storagePath, versionCompareHandle);
        if (!cc.sys.ENABLE_GC_FOR_NATIVE_OBJECTS) {
            this._am.retain();
        }

        this._am.setVerifyCallback(function(path, asset) {
            let compressed = asset.compressed;
            let expectedMD5 = asset.md5;
            let relativePath = asset.path;
            let size = asset.size;
            if (compressed) {
                return true;
            } else {
                return true;
            }
        });
        if (cc.sys.os === cc.sys.OS_ANDROID) {
            this._am.setMaxConcurrentTask(2);
        }
        this.checkUpdate();
    },

    checkUpdate: function() {
        if (this._updating) {
            return;
        }
        if (this._am.getState() === jsb.AssetsManager.State.UNINITED) {
            if (jsb.fileUtils.isFileExist(this.manifestUrl)) {
                console.log('load success:', this.manifestUrl);
                this._am.loadLocalManifest(this.manifestUrl);
            } else {
                let manifest = new jsb.Manifest(this.customManifestStr, this._storagePath);
                console.log('load false:', manifest);
                this._am.loadLocalManifest(manifest, this._storagePath);
            }
        }
        if (!this._am.getLocalManifest() || !this._am.getLocalManifest().isLoaded()) {
            //Failed to load local manifest ...
            console.log('您的版本过旧，请安装最新版');
            return;
        }

        this._checkListener = new jsb.EventListenerAssetsManager(this._am, this.checkCb.bind(this));
        cc.eventManager.addListener(this._checkListener, 1);
        this._am.checkUpdate();
        this._updating = true;
    },

    updateCb: function(event) {
        let needRestart = false;
        let failed = false;
        console.log("升级执行:" + event.getEventCode() + ":" + event.getMessage());
        switch (event.getEventCode()) {
            case jsb.EventAssetsManager.ERROR_NO_LOCAL_MANIFEST:
                console.log("本地配置出错!");
                failed = true;
                break;
            case jsb.EventAssetsManager.ERROR_DOWNLOAD_MANIFEST:
            case jsb.EventAssetsManager.ERROR_PARSE_MANIFEST:
                console.log("远程资源出错!");
                failed = true;
                break;
            case jsb.EventAssetsManager.ALREADY_UP_TO_DATE:
                /*4 已经是最新的*/
                console.log('已经是最新资源');
                /* this.anniu(this.name); */
                //this.getfiles(this.name);
                break;
            case jsb.EventAssetsManager.UPDATE_PROGRESSION:
                /*5 最新进展  做 进度的*/
                console.log(event.getPercentByFile());
                /* this._downloadNode.getComponentInChildren(cc.Label).string = parseInt(event.getPercentByFile() * 100) + "%";
                this._downloadNode.getComponentInChildren(cc.ProgressBar).progress = event.getPercentByFile(); */
                break;
            case jsb.EventAssetsManager.ASSET_UPDATED:
                /*6需要更新*/
                break;
            case jsb.EventAssetsManager.ERROR_UPDATING:
                /*7更新错误*/
                break;
            case jsb.EventAssetsManager.UPDATE_FINISHED:
                /*8更新完成*/
                console.log('更新成功');
                needRestart = true;
                this.anniu(this.name);
                break;
            case jsb.EventAssetsManager.UPDATE_FAILED:
                /*9更新失败*/
                console.log("更新失败", this.name, event.getMessage(), "asdasd");
                this.getfiles(this.name);
                break;
            case jsb.EventAssetsManager.ERROR_DECOMPRESS:
                /*10解压失败*/
                break;
        }
        if (failed) {
            cc.eventManager.removeListener(this._updateListener);
            this._updateListener = null;
            this._updating = false;
        }

        if (needRestart) {
            cc.eventManager.removeListener(this._updateListener);
            this._updateListener = null;
            this._updating = false;
        }
    },

    checkCb: function(event) {

        switch (event.getEventCode()) {
            case jsb.EventAssetsManager.ERROR_NO_LOCAL_MANIFEST:
                // No local manifest file found, hot update skipped.
                break;
            case jsb.EventAssetsManager.ERROR_DOWNLOAD_MANIFEST:
            case jsb.EventAssetsManager.ERROR_PARSE_MANIFEST:
                // Fail to download manifest file, hot update skipped.

                break;
            case jsb.EventAssetsManager.ALREADY_UP_TO_DATE:
                // Already up to date with the latest remote version.
                console.log("检测执行:" + event.getEventCode() + ":已更新至最新版本");
                /* this.getfiles(this.name, 1); */
                break;
            case jsb.EventAssetsManager.NEW_VERSION_FOUND:
                // New version found, please try to update.
                console.log("检测执行:" + event.getEventCode() + ":发现新版本");
                break;
            default:
                return;
        }
        cc.eventManager.removeListener(this._checkListener);
        this._checkListener = null;
        this._updating = false;
        this.hotUpdate();

    },

    hotUpdate: function() {
        if (this._am && !this._updating) {
            this._updateListener = new jsb.EventListenerAssetsManager(this._am, this.updateCb.bind(this));
            cc.eventManager.addListener(this._updateListener, 1);

            if (this._am.getState() === jsb.AssetsManager.State.UNINITED) {
                if (jsb.fileUtils.isFileExist(this.manifestUrl)) {
                    console.log('load success:', this.manifestUrl);
                    this._am.loadLocalManifest(this.manifestUrl);
                } else {
                    let manifest = new jsb.Manifest(this.customManifestStr, this._storagePath);
                    console.log('load false:', manifest);
                    this._am.loadLocalManifest(manifest, this._storagePath);
                }
            }

            this._am.update();

            this._updating = true;
        }
    },

    anniu: function(game) {
        // this._downloadNode.active = false;
        console.log(game, '更新完成，载入游戏中...');
    },

    onDestroy: function() {
        if (this._updateListener) {
            cc.eventManager.removeListener(this._updateListener);
            this._updateListener = null;
        }
        if (this._am && !cc.sys.ENABLE_GC_FOR_NATIVE_OBJECTS) {
            this._am.release();
        }
    },

});